#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Check if client address is listed in specified DNS blacklist
#
# Copyright (c) 2005 JAS
#
# Author: Petr Vokac <vokac@kmlinux.fjfi.cvut.cz>
#
# $Id: Dnsbl.py 26 2006-03-31 00:10:24Z vokac $
#
import logging
from Base import Base


__version__ = "$Revision: 26 $"


class Dnsbl(Base):
    """Check if client address is listed in specified DNS blacklist.
    !!! This module is not yet finished !!!

    Module arguments (see output of getParams method):
    name

    Check arguments:
        None

    Check returns:
        1 .... listed in dnsbl
        0 .... unknown error (e.g. DNS problems)
        -1 ... not listed

    Examples:
        # check if sender mailserver is in ORDB blacklist
        define('dnsbl1', 'Dnsbl', name="ORDB")
    """

    PARAMS = { 'name': ('name of DNS blacklist defined in this module', None),
               }


    def hashArg(self, *args, **keywords):
        data = self.dataArg(0, 'data', {}, *args, **keywords)
        return hash(data.get(client_address, 0))


    def check(self, *args, **keywords):
        data = self.dataArg(0, 'data', {}, *args, **keywords)
        client_address = data.get('client_address')

#        if dnsbl.check(client_address, self.dns, self.type, self.retval):
#            return 1, "%s blacklisted in %s" % (client_address, self.dns)
#        else:
#            return -1, "%s is not in %s blacklist" % (client_address, self.dns)

        return 0, 'not implemented'
